import mpmath as mp
import sys

def calc(C, A, B, Max):
    s = sum(C)
    n = len(C)
    if Max == 0:
        s += 2

    coef = [1]
    for i in range(1,n):
        coef.append(0)
        for j in range(i,0,-1):
            coef[j] -= coef[j-1] * i
    coef = list(map(mp.mpf, map(int, coef)))

    x = [mp.fsum(mp.power(x, -i) for x in range(max(A,n), B+1)) for i in range(s-n,s)]
    num = mp.fdot(coef,x)

    if Max == 0:
        r = sum(coef[i] * mp.zeta(s-n+i) for i in range(n))
    else:
        x = [mp.fsum(mp.power(x, -i) for x in range(n, Max+1)) for i in range(s-n,s)]
        r = mp.fdot(coef,x)
    return num / r

def test_case():
    input()
    N,A,B,Max=map(int,input().split())
    C=list(map(int,input().split()))
    mp.nprint(calc(C,A,B,Max), 20)


def main():
    T=int(input())
    for t in range(T):
        try:
            test_case()
        except ZeroDivisionError:
            print("Div by zero on %d" % (t+1), file=sys.stderr)
            return

if __name__ == "__main__":
    mp.mp.dps = int(sys.argv[1])
    print("dps %d" % (mp.mp.dps), file=sys.stderr)
    main()
